"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JSONEncode = exports.isJSONEncodable = void 0;
function isJSONEncodable(object) {
    return typeof object === "object" && object !== null && "json" in object;
}
exports.isJSONEncodable = isJSONEncodable;
function JSONEncode(object) {
    if (object == null)
        return object;
    if (typeof object !== "object")
        return object;
    if (isJSONEncodable(object))
        return object.json;
    if (Array.isArray(object)) {
        return object.map((value) => JSONEncode(value));
    }
    const clone = {};
    for (const key in object) {
        clone[key] = JSONEncode(object[key]);
    }
    return clone;
}
exports.JSONEncode = JSONEncode;
//# sourceMappingURL=IJSONEncodable.js.map