"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const vitest_1 = require("vitest");
const JSONEncodable_1 = require("./JSONEncodable");
(0, vitest_1.describe)("Codable Tests", () => {
    class CustomJSON extends JSONEncodable_1.JSONEncodable {
        constructor(name, age) {
            super();
            this.name = name;
            this.age = age;
        }
        get json() {
            return {
                introduce: `${this.name} is ${this.age} years old.`,
            };
        }
    }
    class HasCustom extends JSONEncodable_1.JSONEncodable {
        constructor(value) {
            super();
            this.value = value;
        }
    }
    (0, vitest_1.test)("JSONEncodable", () => {
        const custom = new CustomJSON("John", 20);
        const hasCustom = new HasCustom(custom);
        const actual = hasCustom.json;
        const expected = {
            value: {
                introduce: "John is 20 years old.",
            },
        };
        (0, vitest_1.expect)(actual).toEqual(expected);
    });
});
//# sourceMappingURL=JSONEncodable.test.js.map