import { Either } from "./either";
import { None } from "../optional";
export declare class Failure<F, S> implements Either<F, S> {
    private readonly error;
    constructor(error: F);
    readonly isSuccess = false;
    readonly isFailure = true;
    get get(): S;
    get getError(): F;
    map<U>(_: (v: S) => U): Either<F, U>;
    flatMap<U>(_: (v: S) => Either<F, U>): Either<F, U>;
    mapError<U>(f: (error: F) => U): Either<U, S>;
    flatMapError<U>(f: (error: F) => Either<U, S>): Either<U, S>;
    equals(compared: Either<F, S>, _?: (a: S, b: S) => boolean, comparisonFunc?: (a: F, b: F) => boolean): boolean;
    get toOptional(): None<S>;
    get clone(): Failure<F, S>;
}
export declare function failure<F, S>(error: F): Failure<F, S>;
