import { Either } from "./either";
import { Some } from "../optional";
export declare class Success<F, S> implements Either<F, S> {
    private readonly value;
    constructor(value: S);
    readonly isSuccess = true;
    readonly isFailure = false;
    get get(): S;
    get getError(): F;
    map<U>(f: (value: S) => U): Either<F, U>;
    flatMap<U>(f: (value: S) => Either<F, U>): Either<F, U>;
    mapError<U>(_: (error: F) => U): Either<U, S>;
    flatMapError<U>(_: (error: F) => Either<U, S>): Either<U, S>;
    equals(compared: Either<F, S>, comparisonFunc?: (a: S, b: S) => boolean, _?: (a: F, b: F) => boolean): boolean;
    get toOptional(): Some<S>;
    get clone(): Either<F, S>;
}
export declare function success<F, S>(value: S): Success<F, S>;
