"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.none = exports.None = void 0;
const __1 = require("../");
const ts_md5_1 = require("ts-md5");
class None {
    // eslint-disable-next-line @typescript-eslint/no-empty-function
    constructor() {
        this.value = null;
        this.clone = this;
    }
    get get() {
        throw new Error("none to get");
    }
    getOrElse(defaultValue) {
        return defaultValue;
    }
    orElse(defaultValue) {
        return defaultValue;
    }
    isDefined() {
        return false;
    }
    isEmpty() {
        return true;
    }
    map(f) {
        return none();
    }
    flatMap(f) {
        return none();
    }
    equals(compared, _) {
        return compared === None.instance;
    }
    fold(left, right) {
        return left();
    }
    unwrap(or) {
        throw or;
    }
    toEither(error) {
        return (0, __1.failure)(error);
    }
    get json() {
        return null;
    }
    compare(_) {
        return true;
    }
    get hashValue() {
        return ts_md5_1.Md5.hashStr("none");
    }
}
exports.None = None;
None.instance = new None();
function none() {
    return None.instance;
}
exports.none = none;
//# sourceMappingURL=none.js.map