import { Optional } from "./optional";
import { Either } from "../";
import { None } from "./none";
export declare class Some<T> implements Optional<T> {
    readonly value: T;
    constructor(value: T);
    get get(): T;
    getOrElse(defaultValue: T): T;
    orElse(defaultValue: Optional<T>): Optional<T>;
    isDefined(): this is Some<T>;
    isEmpty(): this is None<T>;
    map<U>(f: (value: T) => U): Optional<U>;
    flatMap<U>(f: (value: T) => Optional<U>): Optional<U>;
    equals(compared: Optional<T> | T, comparisonFunc?: (a: T, b: T) => boolean): boolean;
    fold<U>(left: () => U, right: (value: T) => U): U;
    unwrap(_: Error): T;
    toEither<E>(_: E): Either<E, T>;
    get clone(): Some<T>;
    get json(): unknown;
    compare(compared: Optional<T>): boolean;
    get hashValue(): string;
}
export declare function some<T>(value: T): Some<T>;
